﻿Public Class FormGrupos

    Private Sub FormGrupos_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Try
            carregaGrid()
        Catch ex As Exception
            MsgBox(" Erro " & ex.Message)
        End Try
    End Sub
    Private Sub carregaGrid()
        Dim ctx As New Copa2014Entities
        Try
            Dim grupos = From grp In ctx.Grupos Select grp.GrupoId, grp.Nome
            dgvGrupos.DataSource = grupos.ToList()
            formataGrid()
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Exibir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            ctx.Dispose()
        End Try
    End Sub
    Private Sub formataGrid()
        With dgvGrupos
            .AutoGenerateColumns = False
            .AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.DisplayedCellsExceptHeaders
            .ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single
            'altera o nome das colunas
            .Columns(0).HeaderText = "Id"
            .Columns(1).HeaderText = "Grupo"
            .Columns(0).Width = 40
            .Columns(1).Width = 80
            'seleciona a linha inteira
            .SelectionMode = DataGridViewSelectionMode.FullRowSelect
            'não permite seleção de multiplas linhas
            .MultiSelect = False
            .DefaultCellStyle.WrapMode = DataGridViewTriState.True
            .Columns("Nome").DefaultCellStyle.Alignment = DataGridViewContentAlignment.TopCenter
        End With
    End Sub
    Private Sub btnIncluir_Click(sender As Object, e As EventArgs) Handles btnIncluir.Click
        Try
            Using ctx As New Copa2014Entities
                Dim grupo As New Grupos
                grupo.Nome = txtGrupo.Text
                ctx.Grupos.Add(grupo)
                ctx.SaveChanges()
                MessageBox.Show("Grupo incluído com sucesso : " & grupo.Nome.ToString, "Incluir", MessageBoxButtons.OK, MessageBoxIcon.Information)
                txtGrupo.Text = ""
                txtGrupo.Focus()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Incluir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub btnExcluir_Click(sender As Object, e As EventArgs) Handles btnExcluir.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código do Grupo", "Excluir", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim grupo As Grupos = ctx.Grupos.First(Function(grp) grp.GrupoId = codigo)
                txtGrupo.Text = grupo.Nome
                ctx.Grupos.Remove(grupo)
                ctx.SaveChanges()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Excluir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub btnAlterar_Click(sender As Object, e As EventArgs) Handles btnAlterar.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código do Grupo", "Alterar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If
        If String.IsNullOrEmpty(txtGrupo.Text) Then
            MessageBox.Show("Informe o nome do Grupo", "Alterar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim grupo = (From grp In ctx.Grupos Where grp.GrupoId = codigo).SingleOrDefault
                If IsNothing(grupo) Then
                    MessageBox.Show("Categoria não localizada", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Return
                End If
                grupo.Nome = txtGrupo.Text
                ctx.SaveChanges()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Alterar", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub dgvGrupos_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgvGrupos.CellClick
        Try
            If dgvGrupos.Rows(e.RowIndex).Cells(0).Value <> Nothing Then
                Dim codigo As Integer = dgvGrupos.Rows(e.RowIndex).Cells(0).Value

                Try
                    Using ctx As New Copa2014Entities
                        Dim grupo = (From grp In ctx.Grupos Where grp.GrupoId = codigo).SingleOrDefault
                        txtId.Text = grupo.GrupoId
                        txtGrupo.Text = grupo.Nome
                    End Using
                Catch ex As Exception
                    MessageBox.Show("Erro " + ex.Message, "Erro::Localizar", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End Try
            End If
        Catch ex As Exception
            MessageBox.Show("Erro " & ex.Message)
        End Try
    End Sub
    Private Sub SAIRToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SAIRToolStripMenuItem.Click
        Me.Close()
    End Sub
End Class
