﻿Imports System.IO

Public Class FormJogadores

    Private Sub btnProcurar_Click(sender As Object, e As EventArgs) Handles btnProcurar.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código do jogador", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim jogador = (From jog In ctx.Jogadores Where jog.JogadorId = codigo).SingleOrDefault
                If IsNothing(jogador) Then
                    MessageBox.Show("Jogador não localizado", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Return
                End If
                txtNome.Text = jogador.Nome
                cboSelecao.SelectedValue = jogador.SelecaoId
                Dim imageData As Byte() = DirectCast(jogador.JogadorFoto, Byte())
                If Not imageData Is Nothing Then
                    Using ms As New MemoryStream(imageData, 0, imageData.Length)
                        ms.Write(imageData, 0, imageData.Length)
                        picJogadorFoto.Image = Image.FromStream(ms, True)
                    End Using
                Else
                    carregaImagem()
                End If
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Localizar", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub btnIncluir_Click(sender As Object, e As EventArgs) Handles btnIncluir.Click
        Try
            Using ctx As New Copa2014Entities
                Dim jogador As New Jogadores
                jogador.Nome = txtNome.Text
                jogador.SelecaoId = cboSelecao.SelectedValue
                If IsNothing(picJogadorFoto.Image) Then
                    jogador.JogadorFoto = Nothing
                Else
                    Dim ms As New MemoryStream()
                    picJogadorFoto.Image.Save(ms, picJogadorFoto.Image.RawFormat)
                    Dim data As Byte() = ms.GetBuffer()
                    jogador.JogadorFoto = data
                End If
                ctx.Jogadores.Add(jogador)
                ctx.SaveChanges()
                MessageBox.Show("Seleção incluída com sucesso : " & jogador.Nome.ToString, "Incluir", MessageBoxButtons.OK, MessageBoxIcon.Information)
                txtNome.Text = ""
                cboSelecao.SelectedIndex = -1
                picJogadorFoto.Image = Nothing
                txtNome.Focus()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Incluir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub btnSelecionaFoto_Click(sender As Object, e As EventArgs) Handles btnSelecionaFoto.Click
        If ofd1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            picJogadorFoto.Image = Image.FromFile(ofd1.FileName)
        Else
            MessageBox.Show("Operação cancelada", "Selecionar Foto", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub
    Private Sub FormJogadores_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Try
            Using ctx As New Copa2014Entities

                Dim consulta = From selecao In ctx.Selecoes
                               Select selecao

                cboSelecao.DisplayMember = "NomeSelecao"
                cboSelecao.ValueMember = "SelecaoId"
                cboSelecao.DataSource = consulta.ToList

                cboSelecao.SelectedIndex = 0
            End Using
            carregaGrid()
        Catch ex As Exception
            MsgBox(" Erro " & ex.Message)
        End Try
    End Sub
    Private Sub SAIRToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SAIRToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub btnAlterar_Click(sender As Object, e As EventArgs) Handles btnAlterar.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código do Jogador", "Alterar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If
        If String.IsNullOrEmpty(txtNome.Text) Then
            MessageBox.Show("Informe o nome do Jogador", "Alterar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim jogador = (From jog In ctx.Jogadores Where jog.JogadorId = codigo).SingleOrDefault
                If IsNothing(jogador) Then
                    MessageBox.Show("Jogador não localizado", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Return
                End If
                jogador.Nome = txtNome.Text
                jogador.SelecaoId = cboSelecao.SelectedValue
                If IsNothing(picJogadorFoto.Image) Then
                    jogador.JogadorFoto = Nothing
                Else
                    Dim ms As New MemoryStream()
                    picJogadorFoto.Image.Save(ms, picJogadorFoto.Image.RawFormat)
                    Dim data As Byte() = ms.GetBuffer()
                    jogador.JogadorFoto = data
                End If
                ctx.SaveChanges()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Alterar", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub btnExcluir_Click(sender As Object, e As EventArgs) Handles btnExcluir.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código do Jogador", "Excluir", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim jogador As Jogadores = ctx.Jogadores.First(Function(jgd) jgd.JogadorId = codigo)
                ctx.Jogadores.Remove(jogador)
                ctx.SaveChanges()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Excluir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub carregaImagem()
        Dim arquivoSemFoto As String = Application.StartupPath & "\semfoto.jpg"
        picJogadorFoto.Image = Image.FromFile(arquivoSemFoto)
    End Sub

    Private Sub btnLimpar_Click(sender As Object, e As EventArgs) Handles btnLimpar.Click
        txtId.Text = ""
        txtNome.Text = ""
        cboSelecao.SelectedIndex = -1
        picJogadorFoto.Image = Nothing
        txtNome.Focus()
    End Sub
    Private Sub carregaGrid()
        Dim ctx As New Copa2014Entities

        Dim selecaoid As Integer = cboSelecao.SelectedValue

        Try
            Dim jogador = From jog In ctx.Jogadores
                          Where jog.SelecaoId = selecaoid
                          Select jog.JogadorId, jog.Nome, jog.JogadorFoto

            dgvJogadores.DataSource = jogador.ToList()
            formatGrid()
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Exibir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            ctx.Dispose()
        End Try
    End Sub

    Private Sub dgvJogadores_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgvJogadores.CellClick
        Try
            If dgvJogadores.Rows(e.RowIndex).Cells(0).Value <> Nothing Then
                Dim codigo As Integer = dgvJogadores.Rows(e.RowIndex).Cells(0).Value

                Try
                    Using ctx As New Copa2014Entities
                        Dim jogador = (From jog In ctx.Jogadores Where jog.JogadorId = codigo).SingleOrDefault
                        Dim imageData As Byte() = DirectCast(jogador.JogadorFoto, Byte())
                        If Not imageData Is Nothing Then
                            Using ms As New MemoryStream(imageData, 0, imageData.Length)
                                ms.Write(imageData, 0, imageData.Length)
                                picJogadorFoto.Image = Image.FromStream(ms, True)
                            End Using
                            txtId.Text = jogador.JogadorId
                            txtNome.Text = jogador.Nome
                        Else
                            carregaImagem()
                        End If
                    End Using
                Catch ex As Exception
                    MessageBox.Show("Erro " + ex.Message, "Erro::Localizar", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End Try
            End If
        Catch ex As Exception

        End Try
    End Sub
    Private Sub formatGrid()
        With dgvJogadores
            .AutoGenerateColumns = False
            .AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.DisplayedCellsExceptHeaders
            .ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single
            'altera o nome das colunas
            .Columns(0).HeaderText = "Id"
            .Columns(1).HeaderText = "Jogador"
            .Columns(2).HeaderText = "Foto"
            .Columns(0).Width = 40
            .Columns(1).Width = 90
            .Columns(2).Width = 150
            'seleciona a linha inteira
            .SelectionMode = DataGridViewSelectionMode.FullRowSelect
            'não permite seleção de multiplas linhas
            .MultiSelect = False
            .DefaultCellStyle.WrapMode = DataGridViewTriState.True
        End With
    End Sub

    Private Sub cboSelecao_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cboSelecao.SelectedIndexChanged
        carregaGrid()
    End Sub
End Class