﻿Public Class FormJogos

    Private Sub SAIRToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SAIRToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub FormJogos_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        carregaGrupos()
        carregaSedes()
        carregaSelecoes()
        cboHora.SelectedIndex = 0
        carregaGrid()
    End Sub
    Private Sub carregaGrupos()
        Try
            Using ctx As New Copa2014Entities

                Dim consulta = From grupo In ctx.Grupos
                               Where grupo.GrupoId < 9
                               Select grupo

                cboGrupo.DisplayMember = "Nome"
                cboGrupo.ValueMember = "GrupoId"
                cboGrupo.DataSource = consulta.ToList

            End Using
        Catch ex As Exception
            MessageBox.Show(" Erro " & ex.Message & " - " & ex.InnerException.ToString)
        End Try
    End Sub
    Private Sub carregaSelecoes()
        Try
            Using ctx As New Copa2014Entities

                Dim grupoid As Integer = cboGrupo.SelectedValue

                Dim consulta = From selecao In ctx.Selecoes
                               Where selecao.GrupoId = grupoid
                               Select selecao

                '//-------------- seleção 1
                cboSelecao1.DisplayMember = "NomeSelecao"
                cboSelecao1.ValueMember = "SelecaoId"
                cboSelecao1.DataSource = consulta.ToList

                '//--------------seleção 2
                cboSelecao2.DisplayMember = "NomeSelecao"
                cboSelecao2.ValueMember = "SelecaoId"
                cboSelecao2.DataSource = consulta.ToList
            End Using
        Catch ex As Exception
            MessageBox.Show(" Erro " & ex.Message & " - " & ex.InnerException.ToString)
        End Try
    End Sub
    Private Sub carregaSedes()
        Try
            Using ctx As New Copa2014Entities

                Dim consulta = From local In ctx.Locais
                                 Select local

                cboLocal.DisplayMember = "NomeLocal"
                cboLocal.ValueMember = "LocalId"
                cboLocal.DataSource = consulta.ToList

            End Using
        Catch ex As Exception
            MsgBox(" Erro " & ex.Message)
        End Try

    End Sub

    Private Sub btnIncluir_Click(sender As Object, e As EventArgs) Handles btnIncluir.Click
        Try
            Using ctx As New Copa2014Entities
                Dim jogo As New Jogos
                jogo.Data = dtpData.Value
                jogo.Hora = TimeSpan.Parse(GetHoraValida(cboHora.Text))
                jogo.LocalId = cboLocal.SelectedValue
                jogo.GrupoId = cboGrupo.SelectedValue
                jogo.SelecaoId1 = cboSelecao1.SelectedValue
                jogo.SelecaoId2 = cboSelecao2.SelectedValue
                ctx.Jogos.Add(jogo)
                ctx.SaveChanges()
                MessageBox.Show("Jogo incluído com sucesso : " & cboSelecao1.Text & " x " & cboSelecao2.Text, "Incluir", MessageBoxButtons.OK, MessageBoxIcon.Information)
                cboLocal.SelectedIndex = -1
                dtpData.Focus()
                carregaGrid()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Incluir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub carregaGrid()
        Using ctx As New Copa2014Entities
            Try

                Dim grupoid As Integer = cboGrupo.SelectedValue

                Dim jogos = From jg In ctx.Jogos
                            Where jg.GrupoId = grupoid
                            Select jg.JogoId, jg.Data, jg.Hora, jg.Locais.NomeLocal, jg.SelecaoId1, jg.SelecaoId2

                dgvJogos.DataSource = jogos.ToList()
                formatGrid()
            Catch ex As Exception
                MessageBox.Show("Erro " + ex.Message, "Erro::Exibir", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End Using
    End Sub
    Private Function GetHoraValida(ByVal hora As String) As String
        Try
            Dim dt As DateTime = DateTime.ParseExact(hora, "HH:mm", Nothing)
            Return hora
        Catch
            Return "00:00"
        End Try
    End Function

    Private Sub btnAlterar_Click(sender As Object, e As EventArgs) Handles btnAlterar.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código do Jogo", "Alterar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If
        If cboLocal.SelectedIndex = -1 Then
            MessageBox.Show("Selecione o local do jogo", "Alterar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim jogo = (From jog In ctx.Jogos Where jog.JogoId = codigo).SingleOrDefault
                If IsNothing(jogo) Then
                    MessageBox.Show("Jogo não localizado", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Return
                End If
                jogo.Data = dtpData.Value
                jogo.Hora = TimeSpan.Parse(GetHoraValida(cboHora.Text))
                jogo.GrupoId = cboGrupo.SelectedValue
                jogo.LocalId = cboLocal.SelectedValue
                jogo.SelecaoId1 = cboSelecao1.SelectedValue
                jogo.SelecaoId2 = cboSelecao2.SelectedValue
                ctx.SaveChanges()
                carregaGrid()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Alterar", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub btnExcluir_Click(sender As Object, e As EventArgs) Handles btnExcluir.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código do Jogo", "Excluir", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim jogo As Jogos = ctx.Jogos.First(Function(jg) jg.JogoId = codigo)
                ctx.Jogos.Remove(jogo)
                ctx.SaveChanges()
                carregaGrid()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Excluir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub btnProcurar_Click(sender As Object, e As EventArgs) Handles btnProcurar.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código do jogo", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim jogo = (From jog In ctx.Jogos Where jog.JogoId = codigo).SingleOrDefault
                If IsNothing(jogo) Then
                    MessageBox.Show("Jogo não localizado", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Return
                End If
                dtpData.Value = jogo.Data
                cboHora.Text = jogo.Hora.ToString
                cboGrupo.SelectedValue = jogo.GrupoId
                cboLocal.SelectedValue = jogo.LocalId
                cboSelecao1.SelectedValue = jogo.SelecaoId1
                cboSelecao2.SelectedValue = jogo.SelecaoId2
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Localizar", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub cboGrupo_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cboGrupo.SelectedIndexChanged
        carregaSelecoes()
        carregaGrid()
    End Sub
    Private Sub formatGrid()
        With dgvJogos
            .AutoGenerateColumns = False
            .AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.DisplayedCellsExceptHeaders
            .ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single
            'altera a cor das linhas alternadas no grid
            .RowsDefaultCellStyle.BackColor = Color.White
            .AlternatingRowsDefaultCellStyle.BackColor = Color.Aquamarine
            'altera o nome das colunas
            .Columns(0).HeaderText = "Id"
            .Columns(1).HeaderText = "Data"
            .Columns(2).HeaderText = "Hora"
            .Columns(3).HeaderText = "Local"
            .Columns(4).HeaderText = "Seleção"
            .Columns(5).HeaderText = "Seleção"
            .Columns(0).Width = 40
            .Columns(1).Width = 80
            .Columns(2).Width = 50
            .Columns(3).Width = 130
            .Columns(4).Width = 100
            .Columns(5).Width = 100
            'seleciona a linha inteira
            .SelectionMode = DataGridViewSelectionMode.FullRowSelect
            'não permite seleção de multiplas linhas
            .MultiSelect = False
            ' exibe nulos formatados
            .DefaultCellStyle.NullValue = " - "
            'permite que o texto maior que célula não seja truncado
            .DefaultCellStyle.WrapMode = DataGridViewTriState.True
            'define o alinhamamento 
            .Columns("SelecaoId1").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            .Columns("SelecaoId2").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
        End With
    End Sub
    Private Sub cboSelecao1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cboSelecao1.SelectedIndexChanged

        Dim codigo As Integer = cboSelecao1.SelectedValue

        Using ctx As New Copa2014Entities
            Dim selecao = (From sel In ctx.Selecoes Where sel.SelecaoId = codigo).SingleOrDefault
            If IsNothing(selecao) Then
                MessageBox.Show("Seleção não localizada", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Return
            End If
            picSelecao1.Image = Image.FromFile(selecao.Bandeira)
        End Using
    End Sub
    Private Sub cboSelecao2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cboSelecao2.SelectedIndexChanged

        Dim codigo As Integer = cboSelecao2.SelectedValue

        Using ctx As New Copa2014Entities
            Dim selecao = (From sel In ctx.Selecoes Where sel.SelecaoId = codigo).SingleOrDefault
            If IsNothing(selecao) Then
                MessageBox.Show("Seleção não localizada", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Return
            End If
            picSelecao2.Image = Image.FromFile(selecao.Bandeira)
        End Using

    End Sub

    Private Sub dgvJogos_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgvJogos.CellClick
        Try
            If dgvJogos.Rows(e.RowIndex).Cells(0).Value <> Nothing Then
                Dim codigo As Integer = dgvJogos.Rows(e.RowIndex).Cells(0).Value

                Try
                    Using ctx As New Copa2014Entities
                        Dim jogo = (From jog In ctx.Jogos Where jog.JogoId = codigo).SingleOrDefault
                        txtId.Text = jogo.JogoId
                        dtpData.Value = jogo.Data
                        cboHora.Text = jogo.Hora.ToString
                        cboGrupo.SelectedValue = jogo.GrupoId
                        cboLocal.SelectedValue = IIf(jogo.LocalId IsNot Nothing, jogo.LocalId, 0)
                        cboSelecao1.SelectedValue = jogo.SelecaoId1
                        cboSelecao2.SelectedValue = jogo.SelecaoId2
                    End Using
                Catch ex As Exception
                    MessageBox.Show("Erro " + ex.Message, "Erro::Localizar", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End Try
            End If
        Catch ex As Exception

        End Try
    End Sub
End Class