﻿Imports System.IO

Public Class FormSedes

    Private Sub SAIRToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SAIRToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub btnIncluir_Click(sender As Object, e As EventArgs) Handles btnIncluir.Click
        Try
            Using ctx As New Copa2014Entities
                Dim sede As New Locais
                sede.NomeLocal = txtNome.Text
                sede.Endereco = txtEndereco.Text
                If IsNothing(picEstadioFoto.Image) Then
                    sede.LocalFoto = Nothing
                Else
                    Dim ms As New MemoryStream()
                    picEstadioFoto.Image.Save(ms, picEstadioFoto.Image.RawFormat)
                    Dim data As Byte() = ms.GetBuffer()
                    sede.LocalFoto = data
                End If
                ctx.Locais.Add(sede)
                ctx.SaveChanges()
                MessageBox.Show("Estádio Sede incluída com sucesso : " & sede.NomeLocal.ToString, "Incluir", MessageBoxButtons.OK, MessageBoxIcon.Information)
                txtNome.Text = ""
                txtEndereco.Text = ""
                picEstadioFoto.Image = Nothing
                txtNome.Focus()
                carregaGrid()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Incluir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub btnProcurar_Click(sender As Object, e As EventArgs) Handles btnProcurar.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código da sede", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim sede = (From sed In ctx.Locais Where sed.LocalId = codigo).SingleOrDefault
                If IsNothing(sede) Then
                    MessageBox.Show("Sede não localizada", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Return
                End If
                txtNome.Text = sede.NomeLocal
                txtEndereco.Text = sede.Endereco
                Dim imageData As Byte() = DirectCast(sede.LocalFoto, Byte())
                If Not imageData Is Nothing Then
                    Using ms As New MemoryStream(imageData, 0, imageData.Length)
                        ms.Write(imageData, 0, imageData.Length)
                        picEstadioFoto.Image = Image.FromStream(ms, True)
                    End Using
                Else
                    carregaImagem()
                End If
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Localizar", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub carregaImagem()
        Dim arquivoSemFoto As String = Application.StartupPath & "\semfoto.jpg"
        picEstadioFoto.Image = Image.FromFile(arquivoSemFoto)
    End Sub

    Private Sub btnLimpar_Click(sender As Object, e As EventArgs) Handles btnLimpar.Click
        txtId.Text = ""
        txtNome.Text = ""
        txtEndereco.Text = ""
        picEstadioFoto.Image = Nothing
    End Sub

    Private Sub btnAlterar_Click(sender As Object, e As EventArgs) Handles btnAlterar.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código da sede", "Alterar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If
        If String.IsNullOrEmpty(txtNome.Text) Then
            MessageBox.Show("Informe o nome da Sede", "Alterar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim sede = (From sed In ctx.Locais Where sed.LocalId = codigo).SingleOrDefault
                If IsNothing(sede) Then
                    MessageBox.Show("Sede não localizada", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Return
                End If
                sede.NomeLocal = txtNome.Text
                sede.Endereco = txtEndereco.Text
                If IsNothing(picEstadioFoto.Image) Then
                    sede.LocalFoto = Nothing
                Else
                    Dim ms As New MemoryStream()
                    picEstadioFoto.Image.Save(ms, picEstadioFoto.Image.RawFormat)
                    Dim data As Byte() = ms.GetBuffer()
                    sede.LocalFoto = data
                End If
                ctx.SaveChanges()
                carregaGrid()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Alterar", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub btnExcluir_Click(sender As Object, e As EventArgs) Handles btnExcluir.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código da Sede", "Excluir", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim sede As Locais = ctx.Locais.First(Function(sed) sed.LocalId = codigo)
                ctx.Locais.Remove(sede)
                ctx.SaveChanges()
                carregaGrid()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Excluir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub btnSelecionarFoto_Click(sender As Object, e As EventArgs) Handles btnSelecionarFoto.Click
        If ofd1.ShowDialog() = DialogResult.OK Then
            picEstadioFoto.Image = Image.FromFile(ofd1.FileName)
        Else
            MessageBox.Show("Operação cancelada", "Selecionar Foto", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Private Sub dgvSedes_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgvSedes.CellClick
        Try
            If dgvSedes.Rows(e.RowIndex).Cells(0).Value <> Nothing Then
                Dim codigo As Integer = dgvSedes.Rows(e.RowIndex).Cells(0).Value

                Try
                    Using ctx As New Copa2014Entities
                        Dim sede = (From sed In ctx.Locais Where sed.LocalId = codigo).SingleOrDefault
                        Dim imageData As Byte() = DirectCast(sede.LocalFoto, Byte())
                        If Not imageData Is Nothing Then
                            Using ms As New MemoryStream(imageData, 0, imageData.Length)
                                ms.Write(imageData, 0, imageData.Length)
                                picEstadioFoto.Image = Image.FromStream(ms, True)
                            End Using
                            txtId.Text = sede.LocalId
                            txtNome.Text = sede.NomeLocal
                            txtEndereco.Text = sede.Endereco
                        Else
                            carregaImagem()
                        End If
                    End Using
                Catch ex As Exception
                    MessageBox.Show("Erro " + ex.Message, "Erro::Localizar", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End Try
            End If
        Catch ex As Exception

        End Try
    End Sub
    Private Sub carregaGrid()
        Dim ctx As New Copa2014Entities

        Try
            Dim sede = From sed In ctx.Locais
                          Select sed.LocalId, sed.NomeLocal, sed.Endereco

            dgvSedes.DataSource = sede.ToList()
            formatGrid()
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Exibir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            ctx.Dispose()
        End Try
    End Sub
    Private Sub formatGrid()
        With dgvSedes
            .AutoGenerateColumns = False
            .AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.DisplayedCellsExceptHeaders
            .ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single
            'altera o nome das colunas
            .Columns(0).HeaderText = "Id"
            .Columns(1).HeaderText = "Nome Estádio"
            .Columns(2).HeaderText = "Local"
            .Columns(0).Width = 40
            .Columns(1).Width = 180
            .Columns(2).Width = 100
            'seleciona a linha inteira
            .SelectionMode = DataGridViewSelectionMode.FullRowSelect
            'não permite seleção de multiplas linhas
            .MultiSelect = False
            .DefaultCellStyle.WrapMode = DataGridViewTriState.True
        End With
    End Sub

    Private Sub FormSedes_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        carregaGrid()
    End Sub
End Class