﻿Imports System.Security

Public Class FormSelecoes

    Private Sub btnBandeira_Click(sender As Object, e As EventArgs) Handles btnBandeira.Click
        Dim arquivo As String = ""
        Me.ofd1.Multiselect = True
        Me.ofd1.Title = "Selecione a Bandeira"
        ofd1.InitialDirectory = "C:\_vbn\Copa_2014\Copa_2014\Bandeiras"
        'filtra para exibir somente arquivos de imagens
        ofd1.Filter = "Texts (*.gif;*.png)|*.gif;*.png|" & "All files (*.*)|*.*"
        ofd1.CheckFileExists = True
        ofd1.CheckPathExists = True
        ofd1.FilterIndex = 2
        ofd1.RestoreDirectory = True
        ofd1.ReadOnlyChecked = True
        ofd1.ShowReadOnly = True

        Dim dr As DialogResult = Me.ofd1.ShowDialog()

        If dr = System.Windows.Forms.DialogResult.OK Then
            Try
                ' Aqui fica o que deve ser executado com os arquivos selecionados.
                arquivo = ofd1.FileName
                Dim arq As String = ofd1.SafeFileName
                txtBandeira.Text = arquivo
                retornaNomePais(arq)
                exibeBandeira(arquivo)
            Catch ex As SecurityException
                ' O usuário  não possui permissão para ler arquivos
                MessageBox.Show((("Erro de segurança Contate o administrador de segurança da rede." & vbLf & vbLf & "Mensagem : ") + ex.Message & vbLf & vbLf & "Detalhes (enviar ao suporte):" & vbLf & vbLf) + ex.StackTrace)
            Catch ex As Exception
                ' Não pode carregar o arquivo (problemas de permissão)
                MessageBox.Show(("Não é possível exibir a imagem : " & arquivo.Substring(arquivo.LastIndexOf("\"c))))
            End Try
        Else
            MessageBox.Show("Operação cancelada...")
        End If
    End Sub
    Private Sub retornaNomePais(ByVal nomeArquivo As String)
        Try
            Dim posicao_ = nomeArquivo.IndexOf("_")
            Dim nomePais As String = nomeArquivo.Substring(0, posicao_)
            txtSelecao.Text = PrimeiraLetraEmCaixaAlta(nomePais)
        Catch ex As Exception
            Throw ex
        End Try
    End Sub
    Function PrimeiraLetraEmCaixaAlta(ByVal texto As String) As String
        ' verifica se é null
        If String.IsNullOrEmpty(texto) Then
            Return texto
        End If
        ' Converte para um array de caracteres
        Dim array() As Char = texto.ToCharArray
        ' caixa alta no primeiro caractere
        array(0) = Char.ToUpper(array(0))
        ' Retorna uma nova string
        Return New String(array)
    End Function
    Private Sub exibeBandeira(ByVal nomeArquivo As String)
        Try
            Dim bm As New Bitmap(nomeArquivo)
            picBandeira.Image = bm
            picBandeira.SizeMode = PictureBoxSizeMode.AutoSize
        Catch ex As Exception
            Throw ex
        End Try
    End Sub
    Private Sub FormSelecoes_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Try
            Using ctx As New Copa2014Entities
                Dim consulta = From grupo In ctx.Grupos
                                 Select grupo

                cboGrupo.DisplayMember = "Nome"
                cboGrupo.ValueMember = "GrupoId"
                cboGrupo.DataSource = consulta.ToList
            End Using
            carregaGrid()
        Catch ex As Exception
            MsgBox(" Erro " & ex.Message)
        End Try
    End Sub

    Private Sub btnProcurar_Click(sender As Object, e As EventArgs) Handles btnProcurar.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código da seleção", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim selecao = (From sel In ctx.Selecoes Where sel.SelecaoId = codigo).SingleOrDefault
                If IsNothing(selecao) Then
                    MessageBox.Show("Seleção não localizada", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Return
                End If
                txtSelecao.Text = selecao.NomeSelecao
                txtBandeira.Text = selecao.Bandeira
                cboGrupo.SelectedIndex = selecao.GrupoId - 1
                exibeBandeira(selecao.Bandeira)
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Localizar", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub btnIncluir_Click(sender As Object, e As EventArgs) Handles btnIncluir.Click
        Try
            Using ctx As New Copa2014Entities
                Dim selecao As New Selecoes
                selecao.NomeSelecao = txtSelecao.Text
                selecao.Bandeira = txtBandeira.Text
                selecao.GrupoId = cboGrupo.SelectedIndex + 1
                ctx.Selecoes.Add(selecao)
                ctx.SaveChanges()
                MessageBox.Show("Seleção incluída com sucesso : " & selecao.NomeSelecao.ToString, "Incluir", MessageBoxButtons.OK, MessageBoxIcon.Information)
                txtSelecao.Text = ""
                txtBandeira.Text = ""
                txtSelecao.Focus()
                carregaGrid()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Incluir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub btnAlterar_Click(sender As Object, e As EventArgs) Handles btnAlterar.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código da Seleção", "Alterar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If
        If String.IsNullOrEmpty(txtSelecao.Text) Then
            MessageBox.Show("Informe o nome da Seleção", "Alterar", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim selecao = (From sel In ctx.Selecoes Where sel.SelecaoId = codigo).SingleOrDefault
                If IsNothing(selecao) Then
                    MessageBox.Show("Seleção não localizada", "Localizar", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Return
                End If
                selecao.NomeSelecao = txtSelecao.Text
                selecao.Bandeira = txtBandeira.Text
                selecao.GrupoId = cboGrupo.SelectedIndex + 1
                ctx.SaveChanges()
                carregaGrid()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Alterar", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub btnExcluir_Click(sender As Object, e As EventArgs) Handles btnExcluir.Click
        Dim codigo As Integer
        If String.IsNullOrEmpty(txtId.Text) Then
            MessageBox.Show("Informe o código da Seleção", "Excluir", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        Else
            codigo = Convert.ToInt32(txtId.Text)
        End If

        Try
            Using ctx As New Copa2014Entities
                Dim selecao As Selecoes = ctx.Selecoes.First(Function(sel) sel.SelecaoId = codigo)
                'txtSelecao.Text = selecao.Nome
                'txtBandeira.Text = selecao.Bandeira
                'cboGrupo.SelectedIndex = selecao.GrupoId
                ctx.Selecoes.Remove(selecao)
                ctx.SaveChanges()
                carregaGrid()
            End Using
        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Excluir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub carregaGrid()
        Dim ctx As New Copa2014Entities

        Dim grupoid As Integer = cboGrupo.SelectedValue

        Try
            Dim selecao = From sel In ctx.Selecoes
                          Where sel.GrupoId = grupoid
                          Select sel.SelecaoId, sel.NomeSelecao, sel.Bandeira

            dgvSelecoes.DataSource = selecao.ToList()
            formatGrid()

        Catch ex As Exception
            MessageBox.Show("Erro " + ex.Message, "Erro::Exibir", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            ctx.Dispose()
        End Try
    End Sub

    Private Sub SAIRToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SAIRToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub cboGrupo_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cboGrupo.SelectedIndexChanged
        carregaGrid()
    End Sub
    Private Sub formatGrid()
        With dgvSelecoes
            .AutoGenerateColumns = False
            .AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.DisplayedCellsExceptHeaders
            .ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single
            'altera o nome das colunas
            .Columns(0).HeaderText = "Id"
            .Columns(1).HeaderText = "Seleção"
            .Columns(2).HeaderText = "Bandeira"
            .Columns(0).Width = 40
            .Columns(1).Width = 90
            .Columns(2).Width = 330
            'seleciona a linha inteira
            .SelectionMode = DataGridViewSelectionMode.FullRowSelect
            'não permite seleção de multiplas linhas
            .MultiSelect = False
            .DefaultCellStyle.WrapMode = DataGridViewTriState.True
        End With
    End Sub
    Private Sub dgvSelecoes_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgvSelecoes.CellClick
        Try
            If dgvSelecoes.Rows(e.RowIndex).Cells(0).Value <> Nothing Then
                Dim codigo As Integer = dgvSelecoes.Rows(e.RowIndex).Cells(0).Value

                Try
                    Using ctx As New Copa2014Entities
                        Dim selecao = (From sel In ctx.Selecoes Where sel.SelecaoId = codigo).SingleOrDefault
                        exibeBandeira(selecao.Bandeira)
                        txtId.Text = selecao.SelecaoId
                        txtSelecao.Text = selecao.NomeSelecao
                        txtBandeira.Text = selecao.Bandeira
                        cboGrupo.SelectedValue = selecao.GrupoId
                    End Using
                Catch ex As Exception
                    MessageBox.Show("Erro " + ex.Message, "Erro::Localizar", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End Try
            End If
        Catch ex As Exception

        End Try
    End Sub
End Class